[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.91

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.50      afresh1     3: #
1.38      afresh1     4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17:
1.50      afresh1    18: set -o errexit -o pipefail -o nounset
1.85      afresh1    19: set +o monitor
1.77      afresh1    20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50      afresh1    21:
                     22: CFILE=SHA256.sig
                     23: DESTDIR=${DESTDIR:-}
                     24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                     25:
                     26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
                     27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
                     28:
                     29: HTTP_FWDIR="$VNAME"
1.52      afresh1    30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
                     31:     /var/run/dmesg.boot | sed '$!d' )
1.50      afresh1    32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22      afresh1    33:
1.50      afresh1    34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                     35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8       afresh1    36:
1.87      afresh1    37: DOWNLOAD=true
                     38: INSTALL=true
1.69      afresh1    39: LOCALSRC=
                     40:
1.8       afresh1    41: tmpdir() {
                     42:        local _i=1 _dir
                     43:
1.50      afresh1    44:        # If we're not in the installer,
1.79      afresh1    45:        # we have mktemp and a more hostile environment.
1.50      afresh1    46:        if [ -x /usr/bin/mktemp ]; then
                     47:                _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44      afresh1    48:        else
1.50      afresh1    49:                until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    50:                    ((++_i < 10000)) || return 1
                     51:                done
                     52:        fi
1.50      afresh1    53:
1.8       afresh1    54:        echo "$_dir"
                     55: }
1.6       afresh1    56:
1.50      afresh1    57: fetch() {
1.85      afresh1    58:        local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit
1.6       afresh1    59:
1.79      afresh1    60:        # If we're not in the installer,
                     61:        # we have su(1) and doas(1) is unlikely to be configured.
1.85      afresh1    62:        set -o monitor # make sure ftp gets its own process group
                     63:        (
1.53      afresh1    64:        if [ -x /usr/bin/su ]; then
1.85      afresh1    65:                exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.69      afresh1    66:                    "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
1.42      afresh1    67:        else
1.85      afresh1    68:                exec /usr/bin/doas -u "$_user" \
1.69      afresh1    69:                    /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
1.42      afresh1    70:        fi
1.85      afresh1    71:        ) & _pid=$!
                     72:        set +o monitor
                     73:
                     74:        trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
                     75:
                     76:        SECONDS=0
                     77:        _last=0
                     78:        while kill -0 -"$_pid" 2>/dev/null; do
                     79:                if [[ $SECONDS -gt 12 ]]; then
                     80:                        set -- $( ls -ln "$_dst" 2>/dev/null )
                     81:                        if [[ $_last -ne $5 ]]; then
                     82:                                _last=$5
                     83:                                SECONDS=0
                     84:                                sleep 1
                     85:                        else
                     86:                                kill -INT -"$_pid"
                     87:                                echo "fetch timed out" >&2
                     88:                        fi
                     89:                else
                     90:                        sleep 1
                     91:                fi
                     92:        done
                     93:
                     94:        set +o errexit
                     95:        wait "$_pid"
                     96:        _exit=$?
                     97:        set -o errexit
                     98:
                     99:        trap "" EXIT INT QUIT ABRT TERM
1.6       afresh1   100:
1.50      afresh1   101:        if [ "$_exit" -ne 0 ]; then
1.69      afresh1   102:                rm -f "$_dst"
                    103:                echo "Cannot fetch $_src" >&2
1.50      afresh1   104:                return 1
                    105:        fi
1.6       afresh1   106: }
                    107:
1.50      afresh1   108: verify() {
                    109:        # On the installer we don't get sha256 -C, so fake it.
1.69      afresh1   110:        if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                    111:                echo "Checksum test for ${1##*/} failed." >&2
1.50      afresh1   112:                return 1
                    113:        fi
1.6       afresh1   114: }
                    115:
1.50      afresh1   116: devices_needing_firmware() {
1.90      afresh1   117:        local _d _m _line _dmesgtail _last='' _nl=$( echo )
1.1       afresh1   118:
1.50      afresh1   119:        # When we're not in the installer, the dmesg.boot can
                    120:        # contain multiple boots, so only look in the last one
1.89      afresh1   121:        _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
                    122:            grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
1.50      afresh1   123:
1.89      afresh1   124:        grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                    125:            while read -r _d _m; do
                    126:                [ "$_d" = "$_last" ] && continue
1.90      afresh1   127:                [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                    128:                [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
1.83      afresh1   129:
1.89      afresh1   130:                if [[ $_dmesgtail = *$_m* ]]; then
                    131:                        echo "$_d"
                    132:                        _last="$_d"
                    133:                fi
                    134:            done
1.50      afresh1   135: }
1.14      afresh1   136:
1.50      afresh1   137: firmware_filename() {
1.56      afresh1   138:        local _f
                    139:        _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
                    140:        ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                    141:        echo "$_f"
1.50      afresh1   142: }
1.7       afresh1   143:
1.57      afresh1   144: firmware_devicename() {
                    145:        local _d="${1##*/}"
                    146:        _d="${_d%-firmware-*}"
                    147:        echo "$_d"
                    148: }
                    149:
1.50      afresh1   150: installed_firmware() {
                    151:        for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                    152:                [ -e "$fw" ] || continue
                    153:                echo "${fw##*/}"
                    154:        done
                    155: }
1.1       afresh1   156:
1.50      afresh1   157: add_firmware () {
1.74      afresh1   158:        local _f="${1##*/}"
                    159:        local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
1.50      afresh1   160:        ftp -D "Install" -Vmo- "file:${1}" |
1.73      afresh1   161:                tar -s ",^\+,${_pkgdir}/+," \
1.69      afresh1   162:                    -s ",^firmware,${DESTDIR}/etc/firmware," \
                    163:                    -C / -zxphf - "+*" "firmware/*"
1.1       afresh1   164:
1.50      afresh1   165:        # TODO: Should we mark these so real fw_update can -Drepair?
1.73      afresh1   166:        ed -s "${_pkgdir}/+CONTENTS" <<EOL
1.50      afresh1   167: /^@comment pkgpath/ -1a
                    168: @option manual-installation
                    169: @option firmware
                    170: @comment install-script
                    171: .
                    172: w
                    173: EOL
                    174: }
1.22      afresh1   175:
1.50      afresh1   176: delete_firmware() {
1.51      afresh1   177:        local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22      afresh1   178:
1.50      afresh1   179:        # TODO: Check hash for files before deleting
                    180:        echo "Uninstalling $_pkg"
1.51      afresh1   181:        _cwd="${_pkgdir}/$_pkg"
1.50      afresh1   182:
1.51      afresh1   183:        set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50      afresh1   184:
                    185:        while read -r c g; do
                    186:                case $c in
1.51      afresh1   187:                @cwd) _cwd="${DESTDIR}$g"
1.50      afresh1   188:                  ;;
                    189:                @*) continue
                    190:                  ;;
1.52      afresh1   191:                *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50      afresh1   192:                  ;;
                    193:                esac
                    194:        done < "${_pkgdir}/${_pkg}/+CONTENTS"
                    195:
                    196:        # We specifically rm -f here because not removing files/dirs
                    197:        # is probably not worth failing over.
                    198:        for _r in "${_remove[@]}" ; do
                    199:                if [ -d "$_r" ]; then
                    200:                        # Try hard not to actually remove recursively
                    201:                        # without rmdir on the install media.
                    202:                        [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                    203:                else
                    204:                        rm -f "$_r"
1.22      afresh1   205:                fi
                    206:        done
1.50      afresh1   207: }
1.1       afresh1   208:
1.59      afresh1   209: usage() {
1.88      afresh1   210:        echo "usage: fw_install [-D | -L] [driver | file ...]"
1.59      afresh1   211:        exit 2
                    212: }
                    213:
1.87      afresh1   214: OPT_D=
                    215: OPT_L=
1.82      afresh1   216: while getopts DL name
1.59      afresh1   217: do
                    218:        case "$name" in
1.87      afresh1   219:        D) OPT_D=true ;;
                    220:        L) OPT_L=true ;;
1.59      afresh1   221:        ?) usage 2 ;;
                    222:        esac
                    223: done
                    224: shift $((OPTIND - 1))
                    225:
1.87      afresh1   226: [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
                    227:
                    228: if [ "$OPT_D" ]; then
                    229:        # "Download only" means local dir and don't install
                    230:        INSTALL=false
                    231:        LOCALSRC=.
                    232: elif [ "$OPT_L" ]; then
                    233:        # "Local" means don't download, install from local dir
                    234:        DOWNLOAD=false
                    235:        LOCALSRC=.
                    236: else
                    237:        LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
                    238: fi
1.64      afresh1   239:
1.78      afresh1   240: CFILE="$LOCALSRC/$CFILE"
                    241:
1.58      afresh1   242: set -A devices -- "$@"
                    243:
1.65      afresh1   244: if [ ! "${devices[*]:-}" ]; then
1.91    ! afresh1   245:        echo -n "Detecting firmware ..."
        !           246:        set -A devices -- $( devices_needing_firmware )
        !           247:        [ "${devices[*]:-}" ] && echo " found." || echo " done."
1.50      afresh1   248: fi
1.91    ! afresh1   249:
        !           250: [ "${devices[*]:-}" ] || exit
1.50      afresh1   251:
1.71      afresh1   252: if "$DOWNLOAD"; then
1.64      afresh1   253:        fetch "$CFILE"
                    254:        ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                    255:            echo "Signature check of SHA256.sig failed" >&2 && exit 1
                    256: fi
1.50      afresh1   257:
1.70      afresh1   258: for f in "${devices[@]}"; do
                    259:        d="$( firmware_devicename "$f" )"
                    260:
1.58      afresh1   261:        if [ "$f" = "$d" ]; then
                    262:                f=$( firmware_filename "$d" || true )
                    263:                [ "$f" ] || continue
1.69      afresh1   264:                f="$LOCALSRC/$f"
1.76      afresh1   265:        elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70      afresh1   266:                echo "Cannot download local file $f" >&2
                    267:                exit 2
1.58      afresh1   268:        fi
                    269:
1.50      afresh1   270:        set -A installed -- $( installed_firmware "$d" )
                    271:
1.68      afresh1   272:        if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65      afresh1   273:                for i in "${installed[@]}"; do
1.58      afresh1   274:                        if [ "${f##*/}" = "$i.tgz" ]; then
1.50      afresh1   275:                                echo "$i already installed"
1.11      afresh1   276:                                continue 2
1.1       afresh1   277:                        fi
                    278:                done
1.50      afresh1   279:        fi
1.1       afresh1   280:
1.72      afresh1   281:        if [ -e "$f" ]; then
                    282:                if "$DOWNLOAD"; then
                    283:                        echo "Verify existing ${f##*/}"
                    284:                        verify "$f" || continue
                    285:                # else assume it was verified when downloaded
                    286:                fi
1.75      afresh1   287:        elif "$DOWNLOAD"; then
                    288:                fetch  "$f" || continue
                    289:                verify "$f" || continue
                    290:        elif "$INSTALL"; then
1.72      afresh1   291:                echo "Cannot install ${f##*/}, not found" >&2
                    292:                continue
1.58      afresh1   293:        fi
1.60      afresh1   294:
1.68      afresh1   295:        "$INSTALL" || continue
1.11      afresh1   296:
1.65      afresh1   297:        if [ "${installed[*]:-}" ]; then
1.50      afresh1   298:                for i in "${installed[@]}"; do
                    299:                        delete_firmware "$i"
                    300:                done
                    301:        fi
1.11      afresh1   302:
1.50      afresh1   303:        add_firmware "$f"
                    304: done
1.1       afresh1   305:

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>